//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3F6F200103DC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F6F200103DC.cm

//## begin module%3F6F200103DC.cp preserve=no
//## end module%3F6F200103DC.cp

//## Module: Psf%3F6F200103DC; Package specification
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /data/gordon/headas/Xspec/src/XSModel/Model/MixFunction/Psf.h

#ifndef PSF_H
#define PSF_H 1

//## begin module%3F6F200103DC.additionalIncludes preserve=no
//## end module%3F6F200103DC.additionalIncludes

//## begin module%3F6F200103DC.includes preserve=yes
#include <XSContainer.h>
#include <XSstreams.h>
#include <xsTypes.h>
#include <XSUtil/FunctionUtils/FunctionUtility.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSUtil/Numerics/Numerics.h>
#include <XSUtil/Parse/XSparse.h>
#include <CCfits/CCfits>
#include <fstream>
#include <sstream>
#include <cstring>
//## end module%3F6F200103DC.includes

// utility
#include <utility>
// Error
#include <XSUtil/Error/Error.h>
// MixBase
#include <XSModel/Model/Component/MixBase.h>
// PsfRegion
#include <PsfRegion.h>
//## begin module%3F6F200103DC.declarations preserve=no
//## end module%3F6F200103DC.declarations

//## begin module%3F6F200103DC.additionalDeclarations preserve=yes
//## end module%3F6F200103DC.additionalDeclarations


//## begin Psf%3F6F1D770193.preface preserve=yes
//## end Psf%3F6F1D770193.preface

//## Class: Psf%3F6F1D770193; Parameterized Class
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3F747F440383;XSContainer::DataContainer { -> }
//## Uses: <unnamed>%3F97DFC001F3;PsfRegion { -> }

template <typename T>
class Psf : public MixBase  //## Inherits: <unnamed>%3F6F1D8401C3
{
  //## begin Psf%3F6F1D770193.initialDeclarations preserve=yes
  //## end Psf%3F6F1D770193.initialDeclarations

  private:
    //## Class: ImageKeys%3F9D461001D2; private
    //## Category: XSModel::Model::MixFunction%3F7461FF026E
    //## Subsystem: XSModel::Model::MixFunction%3F74624902C0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct ImageKeys 
    {
        //## Constructors (generated)
          ImageKeys();

        // Data Members for Class Attributes

          //## Attribute: xrefval%3F9D46CC0057
          //## begin Psf::ImageKeys::xrefval%3F9D46CC0057.attr preserve=no  public: Real {U} 
          Real xrefval;
          //## end Psf::ImageKeys::xrefval%3F9D46CC0057.attr

          //## Attribute: yrefval%3F9D46E002E2
          //## begin Psf::ImageKeys::yrefval%3F9D46E002E2.attr preserve=no  public: Real {U} 
          Real yrefval;
          //## end Psf::ImageKeys::yrefval%3F9D46E002E2.attr

          //## Attribute: xrefpix%3F9D46F601A9
          //## begin Psf::ImageKeys::xrefpix%3F9D46F601A9.attr preserve=no  public: Real {U} 
          Real xrefpix;
          //## end Psf::ImageKeys::xrefpix%3F9D46F601A9.attr

          //## Attribute: yrefpix%3F9D46FE006F
          //## begin Psf::ImageKeys::yrefpix%3F9D46FE006F.attr preserve=no  public: Real {U} 
          Real yrefpix;
          //## end Psf::ImageKeys::yrefpix%3F9D46FE006F.attr

          //## Attribute: xinc%3F9D471A0108
          //## begin Psf::ImageKeys::xinc%3F9D471A0108.attr preserve=no  public: Real {U} 
          Real xinc;
          //## end Psf::ImageKeys::xinc%3F9D471A0108.attr

          //## Attribute: yinc%3F9D4722010C
          //## begin Psf::ImageKeys::yinc%3F9D4722010C.attr preserve=no  public: Real {U} 
          Real yinc;
          //## end Psf::ImageKeys::yinc%3F9D4722010C.attr

          //## Attribute: rot%3F9D47280254
          //## begin Psf::ImageKeys::rot%3F9D47280254.attr preserve=no  public: Real {U} 
          Real rot;
          //## end Psf::ImageKeys::rot%3F9D47280254.attr

          //## Attribute: coordtype%3F9D4732021D
          //## begin Psf::ImageKeys::coordtype%3F9D4732021D.attr preserve=no  public: char[10] {U} 
          char coordtype[10];
          //## end Psf::ImageKeys::coordtype%3F9D4732021D.attr

      public:
      protected:
      private:
      private: //## implementation
    };

  public:
    //## Class: Rectangle%3FA1608C0110
    //## Category: XSModel::Model::MixFunction%3F7461FF026E
    //## Subsystem: XSModel::Model::MixFunction%3F74624902C0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct Rectangle 
    {
        // Data Members for Class Attributes

          //## Attribute: lowerLeft%3FA160A2004B
          //## begin Psf::Rectangle::lowerLeft%3FA160A2004B.attr preserve=no  public: std::pair<Real,Real> {U} 
          std::pair<Real,Real> lowerLeft;
          //## end Psf::Rectangle::lowerLeft%3FA160A2004B.attr

          //## Attribute: upperRight%3FA160AE00CE
          //## begin Psf::Rectangle::upperRight%3FA160AE00CE.attr preserve=no  public: std::pair<Real,Real> {U} 
          std::pair<Real,Real> upperRight;
          //## end Psf::Rectangle::upperRight%3FA160AE00CE.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Constructors (specified)
      //## Operation: Psf%405B1CEE0267
      Psf (const string& name);

    //## Destructor (generated)
      virtual ~Psf();


    //## Other Operations (specified)
      //## Operation: initialize%3F6F1D8C018D
      virtual void initialize (const std::vector<Real>& params, const std::string& modelName = std::string(""));

      //## Operation: perform%3F7DE8E102EC
      virtual void perform (const EnergyPointer& energy, const std::vector<Real>& params, GroupFluxContainer& flux, GroupFluxContainer& fluxError);

      //## Operation: verifyData%3F8EDAEB01E9
      virtual void verifyData () const;

      //## Operation: initializeForFit%3FA912A202AE
      virtual void initializeForFit (const std::vector<Real>& params, bool paramsAreFrozen);

      //## Operation: refreshTransform%3FAFDA6E000D
      virtual void refreshTransform ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: regions%3F97DFDD0312
      std::vector<std::vector<PsfRegion<T>*> >& regions ();

      //## Attribute: binSizes%3F9FF2FD0277
      const std::vector<Real>& binSizes () const;

      //## Attribute: psfEnergy%3FA297F40312
      const RealArray& psfEnergy () const;

  public:
    // Additional Public Declarations
      //## begin Psf%3F6F1D770193.public preserve=yes
      //## end Psf%3F6F1D770193.public

  protected:
    // Additional Protected Declarations
      //## begin Psf%3F6F1D770193.protected preserve=yes
      //## end Psf%3F6F1D770193.protected

  private:
    //## Constructors (generated)
      Psf(const Psf< T > &right);

    //## Assignment Operation (generated)
      Psf< T > & operator=(const Psf< T > &right);


    //## Other Operations (specified)
      //## Operation: getPosition%3F8EEEC80264
      bool getPosition ();

      //## Operation: readImage%3F9057F0018C
      void readImage (CCfits::PHDU& primaryHDU);

      //## Operation: convertRAorDEC%3F9537D000EA
      Real convertRAorDEC (const string& stringVal, bool isRA);

      //## Operation: clearRegions%3F9817820186
      void clearRegions ();

      //## Operation: clearImageKeys%3F9D4B7C0236
      void clearImageKeys ();

      //## Operation: calcSourceCentersFromCentroid%3F9EAB540002
      void calcSourceCentersFromCentroid ();

      //## Operation: calcSurfaceBrightness%3F9EAC4903C5
      void calcSurfaceBrightness ();

      //## Operation: calcSourceCentersFromUser%3FA00B2B0339
      void calcSourceCentersFromUser ();

      //## Operation: sbFromImageFile%3FA0226A00C1
      void sbFromImageFile ();

      //## Operation: calcRectangle%3FA16B8A01A2
      void calcRectangle (size_t iObs);

      //## Operation: fact%3FA298A2024F
      void fact ();

      //## Operation: mix%3FA691B50361
      void mix (const EnergyPointer& energy, GroupFluxContainer& fluxes, bool isError);

      //## Operation: findPsfEngBracket%3FA6BC0600C8
      int findPsfEngBracket (Real energy, int startFrom = 0) const;

      //## Operation: calcSourceCenters%3FA9218900F5
      void calcSourceCenters ();

      //## Operation: changedParameters%3FA953E4028B
      bool changedParameters (const std::vector<Real>& params) const;

      //## Operation: getImageFile%3FAFECA7015A
      bool getImageFile ();

      //## Operation: readFactFromFile%42F110870272
      bool readFactFromFile (size_t iObs);

      //## Operation: writeFactToFile%42F1111403C2
      bool writeFactToFile (size_t iObs, bool overwrite);

      //## Operation: checkReadWriteStatus%42F24145014B
      bool checkReadWriteStatus () const;

    // Additional Private Declarations
      //## begin Psf%3F6F1D770193.private preserve=yes
      //## end Psf%3F6F1D770193.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: ra%3F8EEA460300
      //## begin Psf::ra%3F8EEA460300.attr preserve=no  private: Real {U} 
      Real m_ra;
      //## end Psf::ra%3F8EEA460300.attr

      //## Attribute: dec%3F8EEAD8007E
      //## begin Psf::dec%3F8EEAD8007E.attr preserve=no  private: Real {U} 
      Real m_dec;
      //## end Psf::dec%3F8EEAD8007E.attr

      //## Attribute: imageFileName%3F8EEB6001DE
      //## begin Psf::imageFileName%3F8EEB6001DE.attr preserve=no  private: string {U} 
      string m_imageFileName;
      //## end Psf::imageFileName%3F8EEB6001DE.attr

      //## Attribute: imageSize%3F8EEE450066
      //## begin Psf::imageSize%3F8EEE450066.attr preserve=no  private: std::pair<int,int> {U} 
      std::pair<int,int> m_imageSize;
      //## end Psf::imageSize%3F8EEE450066.attr

      //## Attribute: NOSET%3F9051CE0309
      //## begin Psf::NOSET%3F9051CE0309.attr preserve=no  private: static const Real {U} -999.0
      static const Real s_NOSET;
      //## end Psf::NOSET%3F9051CE0309.attr

      //## begin Psf::regions%3F97DFDD0312.attr preserve=no  public: std::vector<std::vector<PsfRegion<T>*> > {U} 
      std::vector<std::vector<PsfRegion<T>*> > m_regions;
      //## end Psf::regions%3F97DFDD0312.attr

      //## Attribute: image%3F998DAB0100
      //## begin Psf::image%3F998DAB0100.attr preserve=no  private: RealArray {U} 
      RealArray m_image;
      //## end Psf::image%3F998DAB0100.attr

      //## Attribute: ifKeys%3F9D491103C1
      //## begin Psf::ifKeys%3F9D491103C1.attr preserve=no  private: typename Psf<T>::ImageKeys {U} 
      typename Psf<T>::ImageKeys m_ifKeys;
      //## end Psf::ifKeys%3F9D491103C1.attr

      //## begin Psf::binSizes%3F9FF2FD0277.attr preserve=no  public: std::vector<Real> {U} 
      std::vector<Real> m_binSizes;
      //## end Psf::binSizes%3F9FF2FD0277.attr

      //## Attribute: alpha%3FA0203B0331
      //## begin Psf::alpha%3FA0203B0331.attr preserve=no  private: Real {U} 
      Real m_alpha;
      //## end Psf::alpha%3FA0203B0331.attr

      //## Attribute: beta%3FA0207100EB
      //## begin Psf::beta%3FA0207100EB.attr preserve=no  private: Real {U} 
      Real m_beta;
      //## end Psf::beta%3FA0207100EB.attr

      //## Attribute: core%3FA02088035B
      //## begin Psf::core%3FA02088035B.attr preserve=no  private: Real {U} 
      Real m_core;
      //## end Psf::core%3FA02088035B.attr

      //## Attribute: sbModelType%3FA020A200E1
      //## begin Psf::sbModelType%3FA020A200E1.attr preserve=no  private: int {U} 
      int m_sbModelType;
      //## end Psf::sbModelType%3FA020A200E1.attr

      //## begin Psf::psfEnergy%3FA297F40312.attr preserve=no  public: RealArray {U} 
      RealArray m_psfEnergy;
      //## end Psf::psfEnergy%3FA297F40312.attr

      //## Attribute: factArray%3FA2E912024D
      //## begin Psf::factArray%3FA2E912024D.attr preserve=no  private: RealArray {U} 
      RealArray m_factArray;
      //## end Psf::factArray%3FA2E912024D.attr

      //## Attribute: parametersAreFrozen%3FAFD9780189
      //## begin Psf::parametersAreFrozen%3FAFD9780189.attr preserve=no  private: bool {U} 
      bool m_parametersAreFrozen;
      //## end Psf::parametersAreFrozen%3FAFD9780189.attr

      //## Attribute: dataChanged%405A0BD3022E
      //## begin Psf::dataChanged%405A0BD3022E.attr preserve=no  private: bool {U} 
      bool m_dataChanged;
      //## end Psf::dataChanged%405A0BD3022E.attr

    // Data Members for Associations

      //## Association: XSModel::Model::MixFunction::<unnamed>%3F9EC2DC0306
      //## Role: Psf::sourceCenters%3F9EC2DE0022
      //## begin Psf::sourceCenters%3F9EC2DE0022.role preserve=no  private: std::pair< Real,Real > {1 -> 1..nVHgN}
      std::vector<std::pair< Real,Real > > m_sourceCenters;
      //## end Psf::sourceCenters%3F9EC2DE0022.role

      //## Association: XSModel::Model::MixFunction::<unnamed>%3FA162FA014B
      //## Role: Psf::obsRectangles%3FA162FC0195
      //## begin Psf::obsRectangles%3FA162FC0195.role preserve=no  public: Psf< T >::Rectangle { -> 1..nVHgN}
      std::vector<Rectangle> m_obsRectangles;
      //## end Psf::obsRectangles%3FA162FC0195.role

    // Additional Implementation Declarations
      //## begin Psf%3F6F1D770193.implementation preserve=yes
      //## end Psf%3F6F1D770193.implementation

};

//## begin Psf%3F6F1D770193.postscript preserve=yes
//## end Psf%3F6F1D770193.postscript

//## Class: PsfError%3F9063C701A4
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PsfError : public YellowAlert  //## Inherits: <unnamed>%3F9063E00366
{
  public:
    //## Constructors (specified)
      //## Operation: PsfError%44D0C38300BB
      PsfError (const string& message);

  protected:
  private:
  private: //## implementation
};

// Class Psf::ImageKeys 

// Class Psf::Rectangle 

// Parameterized Class Psf 

//## Get and Set Operations for Class Attributes (inline)

template <typename T>
inline std::vector<std::vector<PsfRegion<T>*> >& Psf<T>::regions ()
{
  //## begin Psf::regions%3F97DFDD0312.get preserve=no
  return m_regions;
  //## end Psf::regions%3F97DFDD0312.get
}

template <typename T>
inline const std::vector<Real>& Psf<T>::binSizes () const
{
  //## begin Psf::binSizes%3F9FF2FD0277.get preserve=no
  return m_binSizes;
  //## end Psf::binSizes%3F9FF2FD0277.get
}

template <typename T>
inline const RealArray& Psf<T>::psfEnergy () const
{
  //## begin Psf::psfEnergy%3FA297F40312.get preserve=no
  return m_psfEnergy;
  //## end Psf::psfEnergy%3FA297F40312.get
}

// Class PsfError 

inline PsfError::PsfError (const string& message)
  //## begin PsfError::PsfError%44D0C38300BB.hasinit preserve=no
  //## end PsfError::PsfError%44D0C38300BB.hasinit
  //## begin PsfError::PsfError%44D0C38300BB.initialization preserve=yes
  :YellowAlert("Psf Error: ")
  //## end PsfError::PsfError%44D0C38300BB.initialization
{
  //## begin PsfError::PsfError%44D0C38300BB.body preserve=yes
   std::cerr << message <<std::endl;
  //## end PsfError::PsfError%44D0C38300BB.body
}


// Class Psf::ImageKeys 

template <typename T>
Psf< T >::ImageKeys::ImageKeys()
  //## begin ImageKeys::ImageKeys%3F9D461001D2_const.initialization preserve=yes
  : xrefval(.0), yrefval(.0), xrefpix(.0), yrefpix(.0), xinc(.0), yinc(.0),
   rot(.0)
  //## end ImageKeys::ImageKeys%3F9D461001D2_const.initialization
{
  //## begin Psf::ImageKeys::ImageKeys%3F9D461001D2_const.body preserve=yes
  strcpy(coordtype, "");
  //## end Psf::ImageKeys::ImageKeys%3F9D461001D2_const.body
}


// Class Psf::Rectangle 

// Parameterized Class Psf 

//## begin Psf::NOSET%3F9051CE0309.attr preserve=no  private: static const Real {U} -999.0
template <typename T>
const Real Psf<T>::s_NOSET = -999.0;
//## end Psf::NOSET%3F9051CE0309.attr

template <typename T>
Psf<T>::Psf (const string& name)
  //## begin Psf::Psf%405B1CEE0267.hasinit preserve=yes
  : MixBase(name),
        m_ra(s_NOSET),
        m_dec(.0),
        m_imageFileName(string("")),
        m_imageSize(0,0),
        m_regions(),
        m_image(),
        m_ifKeys(),
        m_binSizes(),
        m_alpha(.0),
        m_beta(.0),
        m_core(.0),
        m_sbModelType(0),
        m_psfEnergy(),
        m_factArray(),
        m_parametersAreFrozen(true),
        m_dataChanged(false),
        m_sourceCenters(),
        m_obsRectangles()
  //## end Psf::Psf%405B1CEE0267.hasinit
  //## begin Psf::Psf%405B1CEE0267.initialization preserve=yes
  //## end Psf::Psf%405B1CEE0267.initialization
{
  //## begin Psf::Psf%405B1CEE0267.body preserve=yes
  const size_t NE = T::NE;
  const Real* tmp = T::psfEnergy;
  m_psfEnergy.resize(NE);
  m_psfEnergy = RealArray(tmp, NE);
  //## end Psf::Psf%405B1CEE0267.body
}


template <typename T>
Psf<T>::~Psf()
{
  //## begin Psf::~Psf%3F6F1D770193_dest.body preserve=yes
  clearRegions();
  //## end Psf::~Psf%3F6F1D770193_dest.body
}



//## Other Operations (implementation)
template <typename T>
void Psf<T>::initialize (const std::vector<Real>& params, const std::string& modelName)
{
  //## begin Psf::initialize%3F6F1D8C018D.body preserve=yes
  //This function does a complete initialize.  This is what should
  // be called anytime datasets->Notify() is sent, or whenever
  // the model containing this component is first constructed.
  using namespace XSContainer;
  
  clearRegions();
  clearImageKeys();
  
  // NOTE:  this model requires an equal number of spectra
  // in each data group.  
  verifyData();
  size_t nReg = datasets->numberOfGroups();
  size_t nObs = datasets->numberOfSpectra()/datasets->numberOfGroups();
  m_regions.resize(nObs);
  m_sourceCenters.resize(nObs);
  m_binSizes.resize(nObs,.0);
  m_obsRectangles.resize(nObs);
  
  // PsfRegion constructor is very likely to throw on occasion.  
  try
  {  
     for (size_t i=0; i<nObs; ++i)
     {
        std::vector<PsfRegion<T>*>& m_regions_i = m_regions[i];
        m_regions_i.resize(nReg, static_cast<PsfRegion<T>*>(0));
        for (size_t j=0; j<nReg; ++j)
        {
           // Get the spectrum filename that each region in
           // each obs is associated with.  No assumptions made
           // regarding organization of spectra into data sets.
           size_t dummy=0;
           size_t specNum = j*nObs + i + 1;
           string fileName = 
	       datasets->dataSetLookup(specNum, dummy)->getFullPathName();
           m_regions_i[j] = new PsfRegion<T>(fileName);
        }
        // Assumption:  wmrbn, skybin, and pixSize are the same
        // for all regions in an obs.  Therefore, just retrieve
        // it from the first region.
        if (nReg)
        {
           // WMAP binsize in arcminutes
           m_binSizes[i] = 60.0*m_regions_i[0]->pixSize()*m_regions_i[0]->wmrbn()/
                        static_cast<Real>(m_regions_i[0]->skybin());
        }
        calcRectangle(i);
     }
     
     // This can also throw, by way of reading image file.
     m_dataChanged = true;
     initializeForFit(params, true);
  }
  catch (YellowAlert&)
  {
     clearRegions();
     throw;
  }
  //## end Psf::initialize%3F6F1D8C018D.body
}

template <typename T>
void Psf<T>::perform (const EnergyPointer& energy, const std::vector<Real>& params, GroupFluxContainer& flux, GroupFluxContainer& fluxError)
{
  //## begin Psf::perform%3F7DE8E102EC.body preserve=yes
  bool isError(!fluxError.empty());
  mix(energy, flux, false);
  if (isError)
  {
     mix(energy, fluxError, true);
  }
  //## end Psf::perform%3F7DE8E102EC.body
}

template <typename T>
void Psf<T>::verifyData () const
{
  //## begin Psf::verifyData%3F8EDAEB01E9.body preserve=yes
  using namespace XSContainer;
  if (!datasets->dataArray().size())
  {
     throw NoDataPresent("");
  }
  
  // Check that an equal # of spectra are assigned to each data group.
   const size_t nGroups = datasets->numberOfGroups();
   IntegerArray groupCount(nGroups,0);
   int count=0;
   DataArrayConstIt it = datasets->dataArray().begin();
   DataArrayConstIt itEnd = datasets->dataArray().end();
   while (it != itEnd)
   {
      groupCount[it->second->dataGroup()-1] += it->second->numSpectra();
      ++it;
   }
   if (nGroups)
   {
      count = groupCount[0];
   } 
   for (size_t i=1; i<nGroups; ++i)
   {
      if (groupCount[i] != count)
      {
         string msg(": all data groups must have the same number of spectra ");
         throw IncompatibleData(msg);
      }
   } 
  //## end Psf::verifyData%3F8EDAEB01E9.body
}

template <typename T>
bool Psf<T>::getPosition ()
{
  //## begin Psf::getPosition%3F8EEEC80264.body preserve=yes
   const string PSF_RA = T::keywordRoot + string("-RA");
   const string PSF_DEC = T::keywordRoot + string("-DEC");
   bool isChanged = false;
   
   // Routine to get the source center RA and Dec 
   // (in degrees) as set by the user using the XSET command.  
   // If PSF-RA has not been set then m_ra = NOSET. 
   
   Real oldRa = m_ra;
   Real oldDec = m_dec;
     
   m_ra = s_NOSET;
   // If no image file specified, read RA instead.
   const string& raStringVal = FunctionUtility::getModelString(PSF_RA);
   if (raStringVal.length() && raStringVal != FunctionUtility::NOT_A_KEY())
   {
      m_ra = convertRAorDEC(raStringVal, true);
   }
   // Repeat for Dec.
   const string& decStringVal = FunctionUtility::getModelString(PSF_DEC);
   if (decStringVal.length() && decStringVal != FunctionUtility::NOT_A_KEY())
   {
      m_dec = convertRAorDEC(decStringVal, false);
   }
   if (std::fabs(m_ra-oldRa) > 1.0e-6 || std::fabs(m_dec-oldDec) > 1.0e-6)
                isChanged = true; 
   
   return isChanged;
  //## end Psf::getPosition%3F8EEEC80264.body
}

template <typename T>
void Psf<T>::readImage (CCfits::PHDU& primaryHDU)
{
  //## begin Psf::readImage%3F9057F0018C.body preserve=yes
  fitsfile* fp = primaryHDU.fitsPointer();
  fp->HDUposition = 0;
  int status = 0;
  status = fits_read_img_coord(fp, &m_ifKeys.xrefval, &m_ifKeys.yrefval,
             &m_ifKeys.xrefpix,&m_ifKeys.yrefpix, &m_ifKeys.xinc,
             &m_ifKeys.yinc, &m_ifKeys.rot, m_ifKeys.coordtype, &status);
  if (status != 0 && status != APPROX_WCS_KEY)
  {
     std::ostringstream msg;
     msg << "CFITSIO error " << status <<
       " while attempting to read celestial coordinate system keywords\n" <<
       "   from file: " << m_imageFileName;
     throw PsfError(msg.str());
  }
  long nPix = static_cast<long>(m_imageSize.first)*static_cast<long>(m_imageSize.second);
  primaryHDU.read(m_image, 1, nPix);

  //## end Psf::readImage%3F9057F0018C.body
}

template <typename T>
Real Psf<T>::convertRAorDEC (const string& stringVal, bool isRA)
{
  //## begin Psf::convertRAorDEC%3F9537D000EA.body preserve=yes
  // If stringVal contains any ":", assume "hrs:min:sec" format,
  // else assume decimal degrees.
  Real floatVal = 0.0;
  string coord = isRA ? string("RA") : string("DEC");
  if (stringVal.find(':') != string::npos)
  {
     if (!Numerics::AstroFunctions::sexagesimalToDecimal(stringVal, floatVal))
     {
        string msg = "\nFormat error in ";
        msg += coord + " string value as entered with xset command.";
        msg += "\n   Proper format: \"hrs[:min[:sec]]\" or decimal value.";
	msg += "\n   String entered was " + stringVal;
        m_ra = s_NOSET;
        m_dec = .0;
        throw PsfError(msg);
     }
  }
  else
  {
     std::istringstream ssRa(stringVal);
     ssRa >> floatVal;
     if (!ssRa.eof())
     {
        string msg = "\nFormat error in ";
        msg += coord +" string value as entered with xset command.";
        msg += "\n   Proper format: \"hrs[:min[:sec]]\" or decimal value.";
	msg += "\n   String entered was " + stringVal;
        m_ra = s_NOSET;
        m_dec = .0;
        throw PsfError(msg);
     }
  }
  return floatVal;
  //## end Psf::convertRAorDEC%3F9537D000EA.body
}

template <typename T>
void Psf<T>::clearRegions ()
{
  //## begin Psf::clearRegions%3F9817820186.body preserve=yes
  size_t nObs = m_regions.size();
  for (size_t i=0; i<nObs; ++i)
  {
     // When regions container is fully filled, nReg should be 
     // the same for each obs.  But, it may not if we got here 
     // as a result of exception handling.
     std::vector<PsfRegion<T>*>& m_regions_i = m_regions[i];
     size_t nReg = m_regions_i.size();
     for (size_t j=0; j<nReg; ++j)
     {
        delete m_regions_i[j];
     }
  }
  m_regions.clear();   
  //## end Psf::clearRegions%3F9817820186.body
}

template <typename T>
void Psf<T>::clearImageKeys ()
{
  //## begin Psf::clearImageKeys%3F9D4B7C0236.body preserve=yes
  m_ifKeys.xrefval = .0;
  m_ifKeys.yrefval = .0;
  m_ifKeys.xrefpix = .0;
  m_ifKeys.yrefpix = .0;
  m_ifKeys.xinc = .0;
  m_ifKeys.yinc = .0;
  m_ifKeys.rot = .0;
  strcpy(m_ifKeys.coordtype,"");
  //## end Psf::clearImageKeys%3F9D4B7C0236.body
}

template <typename T>
void Psf<T>::calcSourceCentersFromCentroid ()
{
  //## begin Psf::calcSourceCentersFromCentroid%3F9EAB540002.body preserve=yes
  size_t nObs = m_regions.size();
  if (m_sourceCenters.size() != nObs)
  {
     throw RedAlert("Psf source centers array not properly sized");
  }
  for (size_t i=0; i<nObs; ++i)
  {
     const std::vector<PsfRegion<T>*>& regions = m_regions[i];
     size_t nReg = regions.size();
     long wmapTot = 0;
     // rectangle is in detector coordinates
     const std::pair<Real,Real>& lowerLeft = m_obsRectangles[i].lowerLeft;
     int wmrbn = 1;
     m_sourceCenters[i].first = .0;
     m_sourceCenters[i].second = .0;
     for (size_t j=0; j<nReg; ++j)
     {
        int wmapSum = 0;
        const PsfRegion<T>* region = regions[j];
        std::pair<Real,Real> centroid = region->calcCentroid(wmapSum);
        wmapTot += wmapSum;
        // centroid is in wmap bins relative to the particular
        // region's xmin,ymin.  Need to convert it to bins relative
        // to the global rectangle.  This makes the assumption that
        // ALL regions in the same OBS have the same WMRBN value,
        // which converts wmap bins to detector coordinates.
        if (!j)
        {
           wmrbn = region->wmrbn();
        }
        std::pair<Real,Real> offset;
        offset.first = (region->lowerLeft().first - lowerLeft.first)/
                        static_cast<Real>(wmrbn);
        offset.second = (region->lowerLeft().second - lowerLeft.second)/
                        static_cast<Real>(wmrbn);
        m_sourceCenters[i].first += (centroid.first + offset.first)*wmapSum;
        m_sourceCenters[i].second += (centroid.second + offset.second)*wmapSum;
     }
     m_sourceCenters[i].first /= static_cast<Real>(wmapTot);
     m_sourceCenters[i].second /= static_cast<Real>(wmapTot);
  }
  //## end Psf::calcSourceCentersFromCentroid%3F9EAB540002.body
}

template <typename T>
void Psf<T>::calcSurfaceBrightness ()
{
  //## begin Psf::calcSurfaceBrightness%3F9EAC4903C5.body preserve=yes
  // If this function is used, it means there is no user-specified
  // image file from which to get the surface brightness.
  size_t nObs = m_regions.size();
  // Option for integrating over pixel bin
  const int ISUB = 1;  const Real SUBINV = 1.0/ISUB;
  
  for (size_t i=0; i<nObs; ++i)
  {
     size_t nReg = m_regions[i].size();
     const std::pair<Real,Real>& center = m_sourceCenters[i];
     const Rectangle& obsRect = m_obsRectangles[i];
     Real corbin = m_core/m_binSizes[i];
     for (size_t j=0; j<nReg; ++j)
     {
        PsfRegion<T>* region = m_regions[i][j];
        const IntegerArray& wmapPos = region->wmapPos();
        int wmapPosSz = wmapPos.size();
        int nx = region->nx();
        RealArray sbArray(.0, region->nx()*region->ny());
        // For each bin, need its distance from source center in 
        // bin units.  First, calc the offset of the region from the
        // entire observation's xmin,ymin.
        Real xOffset = (region->lowerLeft().first - obsRect.lowerLeft.first)
                        / region->wmrbn();
        Real yOffset = (region->lowerLeft().second - obsRect.lowerLeft.second)
                        / region->wmrbn();
        if (m_sbModelType == 0)
        {
           // Simple beta model           
           for (int k=0; k<wmapPosSz; ++k)
           {
              int ielem = wmapPos[k];
              int ixbin = ielem % nx;
              int iybin = ielem / nx;
              Real x = ixbin + xOffset - center.first;
              Real y = iybin + yOffset - center.second;
              for (int isubx=0; isubx<ISUB; ++isubx)
              {
                 for (int isuby=0; isuby<ISUB; ++isuby)
                 {
                    Real dist2 = (x-(isubx-ISUB/2.+.5)*SUBINV)*
                                 (x-(isubx-ISUB/2.+.5)*SUBINV) +
                                 (y-(isuby-ISUB/2.+.5)*SUBINV)*
                                 (y-(isuby-ISUB/2.+.5)*SUBINV);
                    sbArray[ielem] += SUBINV*SUBINV*pow((1.0+dist2/(corbin*corbin)),
                                        (-3.0*m_beta+.5));
                 }
              }
           }
        }
        else if (m_sbModelType == 1)
        {
           // two slope model
           for (int k=0; k<wmapPosSz; ++k)
           {
              int ielem = wmapPos[k];
              int ixbin = ielem % nx;
              int iybin = ielem / nx;
              Real x = ixbin + xOffset - center.first;
              Real y = iybin + yOffset - center.second;
              for (int isubx=0; isubx<ISUB; ++isubx)
              {
                 for (int isuby=0; isuby<ISUB; ++isuby)
                 {
                    Real dist2 = (x-(isubx-ISUB/2.+.5)*SUBINV)*
                                 (x-(isubx-ISUB/2.+.5)*SUBINV) +
                                 (y-(isuby-ISUB/2.+.5)*SUBINV)*
                                 (y-(isuby-ISUB/2.+.5)*SUBINV);
                    sbArray[ielem] += SUBINV*SUBINV*(pow(dist2,-m_alpha)*
                          exp(-dist2) + pow(dist2,-m_beta)*(1.0-exp(-dist2)));
                 }
              }
           }
        }
        
        // Normalize
        Real sbSum = sbArray.sum();
        if (sbSum != .0)
        {
           sbArray /= sbSum;
        }
        region->surfaceBrightness(sbArray);         
        
     } // end regions loop
  }
  //## end Psf::calcSurfaceBrightness%3F9EAC4903C5.body
}

template <typename T>
void Psf<T>::calcSourceCentersFromUser ()
{
  //## begin Psf::calcSourceCentersFromUser%3FA00B2B0339.body preserve=yes
  size_t nObs = m_regions.size();
  for (size_t i=0; i<nObs; ++i)
  {
     const PsfRegion<T>* region1 = m_regions[i][0];
     Real rapnt = region1->refxcrval();
     Real decpnt = region1->refycrval();
     Real wmrbn = region1->wmrbn();
     Real xpix = region1->refxcrpix();
     Real ypix = region1->refycrpix();
     Real xpos = .0, ypos = .0;
     Real xdelt = region1->refxcdlt();
     Real ydelt = region1->refycdlt();
     char coordtype[] = "-TAN";
     int status = 0;
     fits_world_to_pix(m_ra, m_dec, rapnt, decpnt, xpix, ypix, xdelt, ydelt,
                0.0, coordtype, &xpos, &ypos, &status);
     if (status)
     {
        std::ostringstream msg;
        msg << "CFITSIO error " << status <<
           " while calculating source center from user RA and DEC for obs "
            << i+1;
	msg << "\n Source RA and DEC = " << m_ra << " " << m_dec;
	msg << "\n Reference RA and DEC = " << rapnt << " " << decpnt;
        throw PsfError(msg.str());
     }
     Real wfxf0 = region1->wfxf0();
     Real wfyf0 = region1->wfyf0();
     Real xsign = region1->xsign();
     Real ysign = region1->ysign();
     Real wftheta = region1->wftheta();
     Real xh = region1->wfxh0() + xsign*(xpos-wfxf0)*cos(wftheta)
                - xsign*(ypos-wfyf0)*sin(wftheta);
     Real yh = region1->wfyh0() + ysign*(xpos-wfxf0)*sin(wftheta)
                + ysign*(ypos-wfyf0)*cos(wftheta);
     
     m_sourceCenters[i].first = (xh - m_obsRectangles[i].lowerLeft.first)/wmrbn;
     m_sourceCenters[i].second = (yh - m_obsRectangles[i].lowerLeft.second)/wmrbn;
  }  
  //## end Psf::calcSourceCentersFromUser%3FA00B2B0339.body
}

template <typename T>
void Psf<T>::sbFromImageFile ()
{
  //## begin Psf::sbFromImageFile%3FA0226A00C1.body preserve=yes
  size_t nObs = m_regions.size();
  for (size_t i=0; i<nObs; ++i)
  {
     std::vector<PsfRegion<T>*>& regions_i = m_regions[i];
     size_t nReg = regions_i.size();
     Real rfxval=.0, rfyval=.0, rfxpix=.0, rfypix=.0, rfxdlt=.0, rfydlt=.0;
     Real wfxh0=.0, wfyh0=.0, wfxf0=.0, wfyf0=.0;
     Real xsign=.0, ysign=.0, wftheta=.0;
     int wmrbn=1;
     for (size_t j=0; j<nReg; ++j)
     {
        PsfRegion<T>* region = regions_i[j];
        // Assume these are the same for each region in an obs.
        if (!j)
        {
           rfxval = region->refxcrval();
           rfyval = region->refycrval();
           rfxpix = region->refxcrpix();
           rfypix = region->refycrpix();
           rfxdlt = region->refxcdlt();
           rfydlt = region->refycdlt();
           wmrbn = region->wmrbn();
           wfxh0 = region->wfxh0();
           wfyh0 = region->wfyh0();
           wfxf0 = region->wfxf0();
           wfyf0 = region->wfyf0();
           xsign = region->xsign();
           ysign = region->ysign();
           wftheta = region->wftheta();
        }
        const size_t nx = region->nx();
        const size_t ny = region->ny();
        const Real xmin = region->lowerLeft().first;
        const Real ymin = region->lowerLeft().second;
        RealArray sbArray(.0, nx*ny);
        // For each pixel in sbArray (corresponding to an "on" pixel
        // in the wmap) calculate the sky position, then
        // take that sky position and find the appropriate pixel in the
        // image array.
        const IntegerArray& wmapPos = region->wmapPos();
        int wmapPosSz = wmapPos.size();
        for (int k=0; k<wmapPosSz; ++k)
        {
           int ielem = wmapPos[k];
           int ix = ielem % nx;
           int iy = ielem / nx;
           Real yh = static_cast<Real>(iy*wmrbn) + ymin - wfyh0;
           Real xh = static_cast<Real>(ix*wmrbn) + xmin - wfxh0;

           // Calculate the sky coordinate.
           Real xpxli = wfxf0 + xsign*xh*cos(wftheta) + ysign*yh*sin(wftheta);
           Real ypxli = wfyf0 - xsign*xh*sin(wftheta) + ysign*yh*cos(wftheta);

           Real xpos, ypos, xpxout, ypxout;
           int status = 0;
           char tantype[] = "-TAN";

           // Convert to input surface brightness image coordinates 
           // using the WCS keywords from the image

           fits_pix_to_world(xpxli, ypxli, rfxval, rfyval, rfxpix, rfypix, 
                     rfxdlt, rfydlt, 0.0, tantype, &xpos, &ypos, &status);

           // Convert to input surface brightness image 
           // coordinates using the WCS keywords from the image

          fits_world_to_pix(xpos, ypos, m_ifKeys.xrefval, m_ifKeys.yrefval,
                     m_ifKeys.xrefpix, m_ifKeys.yrefpix, m_ifKeys.xinc,
                     m_ifKeys.yinc, m_ifKeys.rot, m_ifKeys.coordtype, &xpxout,
                     &ypxout, &status);
           if (status)
           {
              std::ostringstream msg;
              msg << "CFITSIO error " << status << 
                " during surface brightness from image file calculation";
              throw PsfError(msg.str());
           }
           int ixpxl = int(xpxout) - 1;
           int iypxl = int(ypxout) - 1;
           if (ixpxl >= 0 && ixpxl < m_imageSize.first &&
                     iypxl >=0 && iypxl < m_imageSize.second)
           {
              sbArray[ielem] = m_image[iypxl*m_imageSize.first+ixpxl];
           }
        }
        // Normalize
        Real sbSum = sbArray.sum();
        if (sbSum != .0)
        {
           sbArray /= sbSum;
        }
        region->surfaceBrightness(sbArray);         
     }
  }
  //## end Psf::sbFromImageFile%3FA0226A00C1.body
}

template <typename T>
void Psf<T>::calcRectangle (size_t iObs)
{
  //## begin Psf::calcRectangle%3FA16B8A01A2.body preserve=yes
  // Get the smallest rectangle that encompasses all the regions
  // in a particular observation.
  const std::vector<PsfRegion<T>*>& regions = m_regions[iObs];
  size_t nReg = regions.size();
  Real globalXmin, globalYmin, globalXmax, globalYmax;
  std::pair<Real,Real> tmp;
  if (nReg)
  {
     tmp = regions[0]->lowerLeft();
     globalXmin = tmp.first;
     globalYmin = tmp.second;
     tmp = regions[0]->upperRight();
     globalXmax = tmp.first;
     globalYmax = tmp.second;
  }
  for (size_t i=1; i<nReg; ++i)
  {
     tmp = regions[i]->lowerLeft();
     globalXmin = std::min(globalXmin, tmp.first);
     globalYmin = std::min(globalYmin, tmp.second);
     tmp = regions[i]->upperRight();
     globalXmax = std::max(globalXmax, tmp.first);
     globalYmax = std::max(globalYmax, tmp.second); 
  }
  m_obsRectangles[iObs].lowerLeft.first = globalXmin;
  m_obsRectangles[iObs].lowerLeft.second = globalYmin;
  m_obsRectangles[iObs].upperRight.first = globalXmax;
  m_obsRectangles[iObs].upperRight.second = globalYmax;
  //## end Psf::calcRectangle%3FA16B8A01A2.body
}

template <typename T>
void Psf<T>::fact ()
{
  //## begin Psf::fact%3FA298A2024F.body preserve=yes
  // Routine to calculate weighting from source to target regions. 
  // Returns fact(i,j,E) which is the weighting from region j to 
  // region i at energy E.
  bool overwrite = checkReadWriteStatus();      
  size_t nObs = m_regions.size();
  // nReg must be the same for each Obs, and if its reached this far
  // it and nObs must be non-zero.
  size_t nReg = m_regions[0].size();
  size_t npsfe = m_psfEnergy.size();
  m_factArray.resize(npsfe*nReg*nReg*nObs, .0);
  for (size_t iObs=0; iObs<nObs; ++iObs)
  {
     if (!readFactFromFile(iObs))
     {
        const std::vector<PsfRegion<T>*>& regions = m_regions[iObs];
        for (size_t iReg=0; iReg<nReg; ++iReg)
        {
           const PsfRegion<T>* sregion = regions[iReg];
           // wmapPos contains the positions of all non-neg pixels.
           const IntegerArray& sourcePixPos = sregion->wmapPos();
           size_t nSourcePix = sourcePixPos.size();
           size_t nxPix = sregion->nx();
           const RealArray& sourceSB = sregion->surfaceBrightness();
           // loop over source detector pixels
           for (size_t indSPix=0; indSPix<nSourcePix; ++indSPix)
           {
              int iSourceIdx = sourcePixPos[indSPix];
              size_t ixPix = iSourceIdx % nxPix;
              size_t iyPix = iSourceIdx / nxPix; 
	      Real SBfact = sourceSB[iSourceIdx];
              // loop over psf energies
              for (size_t ipsfe=0; ipsfe<npsfe; ++ipsfe)
              {
                 T::pointSpreadFunction(*this, iObs, iReg, ixPix, iyPix, ipsfe);
                 // loop over target regions
                 for (size_t itReg=0; itReg<nReg; ++itReg)
                 {
                    const PsfRegion<T>* tregion = regions[itReg];
                    const IntegerArray& targPixPos = tregion->wmapPos();
                    size_t nTargPix = targPixPos.size();
                    const RealArray& targetPSF = tregion->psfArray();
                    size_t iElem = iObs*nReg*nReg*npsfe + nReg*nReg*ipsfe
                                   + nReg*iReg + itReg;
                    // loop over target detector pixels
                    for (size_t indTPix=0; indTPix<nTargPix; ++indTPix)
                    {
                       int iTargIdx = targPixPos[indTPix];
                       // Accumulate in the factArray
                       // NOTE: the order in which the 4-D matrix is
                       // filled into the 1-D factArray is made to
                       // conform with the original FORTRAN code, 
                       // ie. fact(itReg,iReg,ipsfe,iobs) with itReg 
                       // varied first.
                       m_factArray[iElem] += SBfact*targetPSF[iTargIdx];
                    } // end loop over target detector pixels
                 } // end loop over target regions 
              } // end loop over psf energies             
           } // end loop source detector pixels
        } // end regions loop
     } // end if !readFromFile
     writeFactToFile(iObs, overwrite);
  } // end obs loop
  
  if (tpout.consoleChatterLevel() >=25 || tpout.logChatterLevel() >= 25)
  {
     int saveConVerbose = tpout.conVerbose();
     int saveLogVerbose = tpout.logVerbose();
     XSstream::verbose(tpout,25,25);
     tcout << "Psf fact array:" << std::endl;
     for (size_t iObs=0; iObs<nObs; ++iObs)
     {
        tcout << "Obs " << iObs+1 << "\n" << std::endl;
        for (size_t ipsfe=0; ipsfe<npsfe; ++ipsfe)
        {
           tcout << "Energy = " << m_psfEnergy[ipsfe] << std::endl;
           for (size_t itReg=0; itReg<nReg; ++itReg)
           {
              tcout << "  target " << itReg+1 <<": ";
              for (size_t iReg=0; iReg<nReg; ++iReg)
              {
                 size_t iElem = iObs*nReg*nReg*npsfe + nReg*nReg*ipsfe
                                   + nReg*iReg + itReg;
                 tcout << m_factArray[iElem] << " ";
              }
              tcout << std::endl;
           }
           tcout << std::endl;
        }
     }
     XSstream::verbose(tpout,saveConVerbose,saveLogVerbose);
  }
  //## end Psf::fact%3FA298A2024F.body
}

template <typename T>
void Psf<T>::mix (const EnergyPointer& energy, GroupFluxContainer& fluxes, bool isError)
{
  //## begin Psf::mix%3FA691B50361.body preserve=yes
  
  // EnergyPointer and GroupFluxContainer are maps of maps.  
  // The outer map being a collection of regions (data groups),
  // the inner map a collection of obs within the region.
  GroupFluxContainer tmpFlux(fluxes);
  GroupFluxContainer::iterator t(tmpFlux.begin());
  GroupFluxContainer::iterator tEnd(tmpFlux.end());
  // recall ArrayContainer == std::map<size_t,std::valarray<Real> > so that
  // s->second has a vectorized assignment operator that takes a scalar. 
  while ( t != tEnd )
  {
        ArrayContainer::iterator s (t->second.begin());
        ArrayContainer::iterator sEnd (t->second.end());
        for ( ; s != sEnd; ++s ) s->second = 0;
        ++t;         
  }
  
  size_t nReg = fluxes.size();
  size_t nPsfe = m_psfEnergy.size();
  // First loop: target regions (data groups)
  for (size_t itReg=0; itReg<nReg; ++itReg)
  {
     // The keys in the outer map are 1-based (data group nums).
     const ArrayContainer& energyContainer = *(energy.find(itReg+1)->second);
     ArrayContainer& tregFlux = tmpFlux[itReg+1];
     size_t nObs = tregFlux.size();
     // perform for each obs in the target region
     for (size_t iObs=0; iObs<nObs; ++iObs)
     {
        // The inner map keys are specNums, also 1-based.
        int specNum = itReg*nObs + iObs + 1;
        const RealArray& obsEngs = energyContainer.find(specNum)->second;
        RealArray& targetFlux = tregFlux[specNum];
        size_t nE = obsEngs.size();
        size_t startFrom = 0;
        // loop through energies
        for (size_t iEng=0; iEng<nE-1; ++iEng)
        {
           Real centerE = (obsEngs[iEng] + obsEngs[iEng+1])/2.0;
           Real frac0=0.;
           Real frac1=0.;
           // get the psfEnergies which bracket this energy.
           int iPsfe = findPsfEngBracket(centerE, startFrom);
           if (iPsfe < 0)
           {
              startFrom = 0;
              iPsfe = 0;
              frac0 = 1.0;
              frac1 = 0.0;
           }
           else if (iPsfe == nPsfe-1)
           {
              startFrom = iPsfe;
              frac0 = 0.0;
              frac1 = 1.0;
           }
           else
           {
              startFrom = iPsfe;
              Real deltaE = m_psfEnergy[iPsfe+1] - m_psfEnergy[iPsfe];
              frac1 = (centerE - m_psfEnergy[iPsfe])/deltaE;
              frac0 = (m_psfEnergy[iPsfe+1] - centerE)/deltaE;
           }
           // loop over source regions (data groups)
           for (size_t isReg=0; isReg<nReg; ++isReg)
           {
              // See note in fact function for order of elements
              // in m_factArray.
              size_t iElem0 = itReg + isReg*nReg + iPsfe*nReg*nReg + 
                                iObs*nPsfe*nReg*nReg;
              // Equivalent to incrementing iPsfe by 1 in above equation.
              size_t iElem1 = iElem0 + nReg*nReg;
              // Carefull, if iPsfe==nPsfe-1, then iElem1 is out of bounds.
              // But, in that case frac1 will be 0.0 anyway.
              Real weight = frac0*m_factArray[iElem0];
              if (iPsfe != (nPsfe-1))
              {
                 weight += frac1*m_factArray[iElem1];
              } 
              int specNum = isReg*nObs + iObs + 1;
              RealArray& sourceFlux = fluxes[isReg+1][specNum];
              if (isError)
              {
                 weight *= weight;
              }
              targetFlux[iEng] += sourceFlux[iEng]*weight;                            
           }
        } // end loop over energies
     } // end loop over obs     
  } // end loop over target regions
  fluxes = tmpFlux;
  
  //## end Psf::mix%3FA691B50361.body
}

template <typename T>
int Psf<T>::findPsfEngBracket (Real energy, int startFrom) const
{
  //## begin Psf::findPsfEngBracket%3FA6BC0600C8.body preserve=yes
  // Given an input energy, this function should find the energies 
  // that bracket it in the m_psfEnergy array.  It returns the index
  // of the lower energy of the bracket.  If energy is less than
  // all energies in the psfArray, it returns -1 (unless startFrom
  // parameter is used). If energy is greater than all psfArray 
  // energies, it returns nPsfe-1.
  
  // If startFrom parameter is used, only begin the search from 
  // index = startFrom.
  int iLowPsfe = (startFrom > 0) ? startFrom-1 : -1;
  int nPsfe = static_cast<int>(m_psfEnergy.size());
  if (energy >= m_psfEnergy[iLowPsfe + 1])
  {
     ++iLowPsfe;
     // iLowPsfe should now = 0, or startFrom, and 
     // energy is >= m_psfEnergy[iLowPsfe].
     while (iLowPsfe < (nPsfe-1) && energy >= m_psfEnergy[iLowPsfe+1])
     {
        ++iLowPsfe;
     }
     // Either m_psfEnergy[iLowPsfe] <= energy < m_psfEnergy[iLowPsfe+1]
     // or m_psfEnergy[nPsfe-1] <= energy.
  }
  return iLowPsfe;
  //## end Psf::findPsfEngBracket%3FA6BC0600C8.body
}

template <typename T>
void Psf<T>::initializeForFit (const std::vector<Real>& params, bool paramsAreFrozen)
{
  //## begin Psf::initializeForFit%3FA912A202AE.body preserve=yes
  // This is the initialization that should be performed in response
  // to a fit command, or a fit update call.  It is a subset of the  
  // general initialize function.
  bool paramsChanged = changedParameters(params);
  bool imageFileChanged = getImageFile();
  bool usingImageFile = m_imageFileName.length();
  bool positionChanged = getPosition();
  m_parametersAreFrozen = paramsAreFrozen;
  
  // If we got here immediately after first getting here from the 
  // initialize function (such as from the datasets->models->fit 
  // notify update chain), no problem. In that case, nothing below 
  // will be done. 
  if (paramsChanged)
  {
     m_alpha = params[0];
     m_beta = params[1];
     m_core = params[2];
     m_sbModelType = static_cast<int>(params[3]);
     if (usingImageFile)
     {
        tcout << "\n***Warning: psf mix model is calculating surface brightness from"
             << "\nuser specified image file.  Therefore, changing the mix model"
             << "\nparameters will have no effect on the calculation." 
             <<std::endl;
     }
  }
  
  if (m_dataChanged || positionChanged || paramsChanged || imageFileChanged)
  {
     if (usingImageFile)
     {
        if (imageFileChanged)
        {
           sbFromImageFile();
        }
     }
     else
     {
       // Although we're not reading from an image file, we still 
       // can get here when only the imageFileChanged flag 
       // is true.  In that case, the file name has been erased, 
       // yet ra,dec, and the params remain unchanged. The
       // surfaceBrightness array still needs to be recalculated.
        calcSourceCenters();
        calcSurfaceBrightness();
     }
     fact();
     // Now that m_dataChanged has had its desired effect, reset.
     m_dataChanged = false;
  }  
  //## end Psf::initializeForFit%3FA912A202AE.body
}

template <typename T>
void Psf<T>::calcSourceCenters ()
{
  //## begin Psf::calcSourceCenters%3FA9218900F5.body preserve=yes
  // If no RA, DEC specified, will need to get source center
  // from centroid of regions.
  if (m_ra == s_NOSET)
  {
     calcSourceCentersFromCentroid();
  }
  else
  {
     calcSourceCentersFromUser();
  }
  //## end Psf::calcSourceCenters%3FA9218900F5.body
}

template <typename T>
bool Psf<T>::changedParameters (const std::vector<Real>& params) const
{
  //## begin Psf::changedParameters%3FA953E4028B.body preserve=yes
  return (std::fabs(m_alpha-params[0]) > 1.0e-6 ||
          std::fabs(m_beta-params[1]) > 1.0e-6  ||
          std::fabs(m_core-params[2]) > 1.0e-6  ||
          m_sbModelType != static_cast<int>(params[3]));
  //## end Psf::changedParameters%3FA953E4028B.body
}

template <typename T>
void Psf<T>::refreshTransform ()
{
  //## begin Psf::refreshTransform%3FAFDA6E000D.body preserve=yes
  if (!m_imageFileName.length() && !m_parametersAreFrozen)
  {
     calcSurfaceBrightness();
     fact();
  }
  //## end Psf::refreshTransform%3FAFDA6E000D.body
}

template <typename T>
bool Psf<T>::getImageFile ()
{
  //## begin Psf::getImageFile%3FAFECA7015A.body preserve=yes
  using namespace CCfits;
  bool isChanged = false;
  const string PSF_IMAGE = T::keywordRoot + string("-IMAGE");
  string oldImageFile(m_imageFileName);
  std::pair<int,int> oldImageSize(m_imageSize);
  m_imageFileName = "";
  m_imageSize = std::pair<int,int>(0,0);
  
  const string& imageFile = FunctionUtility::getModelString(PSF_IMAGE);
  if (imageFile.length() && imageFile != FunctionUtility::NOT_A_KEY())
  {
     m_imageFileName = imageFile;
     try
     {
        std::auto_ptr<FITS> p(new FITS(m_imageFileName));
        PHDU& primary = p->pHDU();

        if (primary.axes() == 2)
        {
           m_imageSize.first = static_cast<int>(primary.axis(0));
           m_imageSize.second = static_cast<int>(primary.axis(1));
        }
        else
        {
           string msg("Primary HDU does not have 2 axes in image file");
           throw PsfError(msg);        
        }
        isChanged = (m_imageFileName != oldImageFile || m_imageSize != oldImageSize);
        if (isChanged)
        {
           readImage(primary);
        }
     }
     catch (CCfits::FITS::CantOpen)
     {
        string msg = "Cannot open image file: ";
        msg += m_imageFileName;
        throw PsfError(msg);
     }
     catch (CCfits::FitsException&)
     {
        string msg = "Error attempting to read image from file: ";
        msg += m_imageFileName;
        throw PsfError(msg);
     }
  }
  else
  {
     isChanged = (oldImageFile != string(""));
  }
  
  return isChanged;
  //## end Psf::getImageFile%3FAFECA7015A.body
}

template <typename T>
bool Psf<T>::readFactFromFile (size_t iObs)
{
  //## begin Psf::readFactFromFile%42F110870272.body preserve=yes
   using namespace CCfits;
   bool status = false;
   const int savCon = tpout.conVerbose();
   const int savLog = tpout.logVerbose();
   const string nameKeyRoot = T::keywordRoot + string("-MIXFACT-IFILE");
   
   XSstream::verbose(tpout, 25, 25);
   tcout << "Psf::readFactFromFile: Entry" << std::endl;
   std::ostringstream osstmp;
   osstmp << nameKeyRoot << iObs+1;
   const string nameKey(osstmp.str());
   const string fileName(FunctionUtility::getModelString(nameKey));
   if (fileName != FunctionUtility::NOT_A_KEY())
   {
      string errContext("Failed to open fact file: ");
      try
      {
         std::auto_ptr<FITS> pFile(new FITS(fileName));
         errContext = "Error reading header keys: ";
         PHDU& header = pFile->pHDU();
         long bitpix = header.bitpix();
         int nAxes = static_cast<int>(header.axes());
         errContext = "Fact file has wrong structure: ";
         if (bitpix != -64 || nAxes != 3)
            throw YellowAlert();
         int nRegs = m_regions[iObs].size();
         if (header.axis(0) != nRegs || header.axis(1) != nRegs
                || header.axis(2) != m_psfEnergy.size())
            throw YellowAlert();
         errContext = "Error reading fact array from image: ";
         long szCube = nRegs*nRegs*m_psfEnergy.size(); 
         RealArray tmpFact(.0, szCube); 
         header.read(tmpFact, 1, szCube);
         // Avoiding using a slice_array even though it may be
         // quicker due to some compilation trouble on 
         // Sci.Linux 4.0 w/ gcc 3.4.3.
         size_t offset = iObs*szCube;
         for (size_t i=0; i<static_cast<size_t>(szCube); ++i)
         {
            m_factArray[offset + i] = tmpFact[i];
         }
         status = true;
         XSstream::verbose(tpout, savCon, savLog);
         tcout << "  Successfully read " << fileName << std::endl;
      }
      catch (...)
      {
         XSstream::verbose(tpout, savCon, savLog);
         string msg = errContext + fileName + "\n";
         throw YellowAlert(msg);
      }
   }
   XSstream::verbose(tpout, savCon, savLog);
   return status;
  //## end Psf::readFactFromFile%42F110870272.body
}

template <typename T>
bool Psf<T>::writeFactToFile (size_t iObs, bool overwrite)
{
  //## begin Psf::writeFactToFile%42F1111403C2.body preserve=yes
   
   using namespace CCfits;
   bool status = false;
   const int savCon = tpout.conVerbose();
   const int savLog = tpout.logVerbose();
   const string nameKeyRoot = T::keywordRoot + string("-MIXFACT-OFILE");
   
   XSstream::verbose(tpout, 25, 25);
   tcout << "Psf::writeFactToFile Entry" << std::endl;
   std::ostringstream osstmp;
   osstmp << nameKeyRoot << iObs+1;
   const string nameKey(osstmp.str());
   const string fileName(FunctionUtility::getModelString(nameKey));
   if (fileName != FunctionUtility::NOT_A_KEY())
   {
      string errContext("Failed to initialize fact file: ");
      try
      {
         bool doWrite = true;
         // Test for already existing file.
         std::ifstream testFile(fileName.c_str());
         if (testFile && !overwrite)
         {
            doWrite = false;
         }
         testFile.close();
         if (doWrite)
         {
            const int bitpix = -64;
            const int nAxes = 3;
            long axisLengths[nAxes];
            const int nRegs = m_regions[iObs].size();
            axisLengths[0] = axisLengths[1] = static_cast<long>(nRegs);
            axisLengths[2] = static_cast<long>(m_psfEnergy.size());
            string qualFileName(fileName);
            // The '!' will force overwrites.
            qualFileName.insert(0, "!");
            std::auto_ptr<FITS> pFile(new FITS(qualFileName, bitpix, nAxes, axisLengths)); 
            errContext = "Failed to write data array: ";
            long szCube = nRegs*nRegs*m_psfEnergy.size();
            RealArray factSlice = m_factArray[std::slice(iObs*(size_t)szCube, 
                                (size_t)szCube, 1)];
            pFile->pHDU().write(1, szCube, factSlice);          
            status = true;
            XSstream::verbose(tpout, savCon, savLog);
            tcout << "  Successfully wrote " << fileName << std::endl;
         }
      }
      catch (...)
      {
         XSstream::verbose(tpout, savCon, savLog);
         string msg = errContext + fileName + "\n";
         throw YellowAlert(msg);
      }
   }   
   XSstream::verbose(tpout, savCon, savLog);   
   return status;
  //## end Psf::writeFactToFile%42F1111403C2.body
}

template <typename T>
bool Psf<T>::checkReadWriteStatus () const
{
  //## begin Psf::checkReadWriteStatus%42F24145014B.body preserve=yes
   bool status = true;
   size_t nObs = m_regions.size();
   const string inNameKeyRoot = T::keywordRoot + string("-MIXFACT-IFILE");
   const string outNameKeyRoot = T::keywordRoot + string("-MIXFACT-OFILE");
   // If any requested input files are missing, throw.
   for (size_t i=0; i<nObs; ++i)
   {
      std::ostringstream osstmp;
      osstmp << inNameKeyRoot << i+1;
      const string nameKey(osstmp.str());
      const string fileName(FunctionUtility::getModelString(nameKey));
      if (fileName == FunctionUtility::NOT_A_KEY())
      {
         tcout << "   No " << nameKey << " specified." << std::endl;
      }
      else
      {
         // Test for already existing file.
         std::ifstream testFile(fileName.c_str());
         if (!testFile)
         {
            string errMsg("Cannot open input fact array file: ");
            errMsg += fileName;
            throw PsfError(errMsg);
         }
      }
   }
   // If any output files exist, prompt user (all or nothing).
   StringArray existingFiles;
   for (size_t i=0; i<nObs; ++i)
   {
      std::ostringstream osstmp;
      osstmp << outNameKeyRoot << i+1;
      const string nameKey(osstmp.str());
      const string fileName(FunctionUtility::getModelString(nameKey));
      if (fileName == FunctionUtility::NOT_A_KEY())
      {
         tcout << "   No " << nameKey << " specified." << std::endl;
      }
      else
      {
         std::ifstream testFile(fileName.c_str());
         if (testFile)
         {
            existingFiles.push_back(fileName);
         }         
      }
   }
   if (existingFiles.size())
   {
      tcout << "The following requested output fact files already exist:"<<std::endl;
      for (size_t i=0; i<existingFiles.size(); ++i)
         tcout << "    " << existingFiles[i] << std::endl;
      string prompt("Do you want to replace these (y/n/a(bort))?");
      string reply;
      XSparse::basicPrompt(prompt, reply);
      status = reply.length() && (reply[0] == 'y' || reply[0] == 'Y');
      if (reply.length() && (reply[0] == 'a' || reply[0] == 'A'))
      {
         throw XSparse::AbortLoop();
      }  
   }
   return status;
  //## end Psf::checkReadWriteStatus%42F24145014B.body
}

// Additional Declarations
  //## begin Psf%3F6F1D770193.declarations preserve=yes
  //## end Psf%3F6F1D770193.declarations

//## begin module%3F6F200103DC.epilog preserve=yes
//## end module%3F6F200103DC.epilog


#endif
